commit d228af5cbc2f635d0837ed67fe95641d6e567aff
Author: Richard Sandiford <richard.sandiford@arm.com>
Date:   Fri Nov 8 14:07:46 2024 +0000

    aarch64: Restrict FCLAMP to SME2
    
    There are two sets of patterns for FCLAMP: one set for single registers
    and one set for multiple registers.  The multiple-register set was
    correctly gated on SME2, but the single-register set only required SME.
    This doesn't matter for ACLE usage, since the intrinsic definitions
    are correctly gated.  But it does matter for automatic generation of
    FCLAMP from separate minimum and maximum operations (either ACLE
    intrinsics or autovectorised code).
    
    gcc/
            * config/aarch64/aarch64-sve2.md (@aarch64_sve_fclamp<mode>)
            (*aarch64_sve_fclamp<mode>_x): Require TARGET_STREAMING_SME2
            rather than TARGET_STREAMING_SME.
    
    gcc/testsuite/
            * gcc.target/aarch64/sme/clamp_3.c: Force sme2
            * gcc.target/aarch64/sme/clamp_4.c: Likewise.
            * gcc.target/aarch64/sme/clamp_5.c: New test.
    
    (cherry picked from commit f5962839d6e0c3115931e68d938d9a0cd7a383b1)

diff --git a/gcc/testsuite/gcc.target/aarch64/sme/clamp_3.c b/gcc/testsuite/gcc.target/aarch64/sme/clamp_3.c
index 44959f79490..162de6224d5 100644
--- a/gcc/testsuite/gcc.target/aarch64/sme/clamp_3.c
+++ b/gcc/testsuite/gcc.target/aarch64/sme/clamp_3.c
@@ -2,6 +2,8 @@
 
 #include <arm_sme.h>
 
+#pragma GCC target "+sme2"
+
 #define TEST(TYPE)							\
   TYPE									\
   tied1_##TYPE(TYPE a, TYPE b, TYPE c) __arm_streaming			\
diff --git a/gcc/testsuite/gcc.target/aarch64/sme/clamp_4.c b/gcc/testsuite/gcc.target/aarch64/sme/clamp_4.c
index 643b2635b90..453c82cd860 100644
--- a/gcc/testsuite/gcc.target/aarch64/sme/clamp_4.c
+++ b/gcc/testsuite/gcc.target/aarch64/sme/clamp_4.c
@@ -2,6 +2,8 @@
 
 #include <arm_sme.h>
 
+#pragma GCC target "+sme2"
+
 #define TEST(TYPE)							\
   TYPE									\
   untied_##TYPE(TYPE a, TYPE b, TYPE c, TYPE d) __arm_streaming		\
diff --git a/gcc/testsuite/gcc.target/aarch64/sme/clamp_5.c b/gcc/testsuite/gcc.target/aarch64/sme/clamp_5.c
new file mode 100644
index 00000000000..7c5464bdc36
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/sme/clamp_5.c
@@ -0,0 +1,24 @@
+// { dg-options "-O" }
+
+#include <arm_sme.h>
+
+#pragma GCC target "+nosme2"
+
+#define TEST(TYPE)							\
+  TYPE									\
+  tied1_##TYPE(TYPE a, TYPE b, TYPE c) __arm_streaming			\
+  {									\
+    return svminnm_x(svptrue_b8(), svmaxnm_x(svptrue_b8(), a, b), c);	\
+  }									\
+									\
+  TYPE									\
+  tied2_##TYPE(TYPE a, TYPE b, TYPE c) __arm_streaming			\
+  {									\
+    return svminnm_x(svptrue_b8(), svmaxnm_x(svptrue_b8(), b, a), c);	\
+  }
+
+TEST(svfloat16_t)
+TEST(svfloat32_t)
+TEST(svfloat64_t)
+
+/* { dg-final { scan-assembler-not {\tfclamp\t} } } */

